----------------------------------------------------------------------------
-- @Author: ViperGTS96-----------------------------------------------------
----------------------------------------------------------------------------
--------------------"The simplest design is the best design." --------------
----------------------------------------------------------------------------
----------------------------------------------------------------------------

RealDirtFix = {};

function RealDirtFix:updateDirtAmount(superFunc, nodeData, dt)
    local spec = self.spec_washable;
    local change = 0;
    --[[if self:getAllowsWashingByType(Washable.WASHTYPE_RAIN) then
        local weather = g_currentMission.environment.weather;
        local rainScale = weather:getRainFallScale();
        local timeSinceLastRain = weather:getTimeSinceLastRain();
        if rainScale > 0.1 and timeSinceLastRain < 30 then
            local amount = self:getNodeDirtAmount(nodeData);
            if amount > 0.5 then
                change = -(dt / spec.washDuration);
            end;
        end;
    end;]]
    local dirtMultiplier = self:getDirtMultiplier();
    if dirtMultiplier ~= 0 then
        change = dt * spec.dirtDuration * dirtMultiplier * Washable.getIntervalMultiplier();
    end;
    return change;
end;

function RealDirtFix:updateWheelDirtAmount(superFunc, nodeData, dt)
    local dirtAmount = self:updateDirtAmount(nodeData, dt);
    local allowManipulation = true;
    if nodeData.wheel ~= nil then
        if nodeData.wheel.contact == Wheels.WHEEL_NO_CONTACT then
            allowManipulation = false;
        end;
    end;
    if allowManipulation then
        local isOnField = false;
        if nodeData.wheel ~= nil then
            if nodeData.wheel.densityType ~= 0 then -- and nodeData.wheel.densityType ~= g_currentMission.grassValue then
                isOnField = true;
            end;
        end;
        if isOnField then
            dirtAmount = dirtAmount * nodeData.fieldDirtMultiplier;
        --[[else
            if self:getNodeDirtAmount(nodeData) > nodeData.minDirtPercentage then
                local speedFactor = self:getLastSpeed() / 20;
                dirtAmount = dirtAmount * nodeData.streetDirtMultiplier * speedFactor;
            end;]]
        end;
    end;
    return dirtAmount;
end;

function RealDirtFix:getTireTrackColor(superFunc, wheel, wx, wy, wz)
    local r, g, b, a, t = nil, nil, nil, 0, nil;
    if wheel.contact == Wheels.WHEEL_GROUND_CONTACT then
        local isOnField = wheel.densityType ~= 0;
        --local dirtAmount = 1;
        if isOnField then
            r, g, b, a = FSDensityMapUtil.getTireTrackColorFromDensityBits(wheel.densityBits);
            t = 1.0;
            --[[if wheel.densityType == g_currentMission.grassValue then
                dirtAmount = 0.7;
            end;]]
        else
            r, g, b, a, t = getTerrainAttributesAtWorldPos(g_currentMission.terrainRootNode, wx, wy, wz, true, true, true, true, false);
            --dirtAmount = 0.5
       end;
        --wheel.dirtAmount = dirtAmount;
        wheel.lastColor[1] = r;
        wheel.lastColor[2] = g;
        wheel.lastColor[3] = b;
        wheel.lastColor[4] = a;
        wheel.lastTerrainAttribute = t;
    elseif wheel.contact == Wheels.WHEEL_OBJ_CONTACT then
        if wheel.dirtAmount > 0 then
            local maxTrackLength = 30 * (1 + g_currentMission.environment.weather:getGroundWetness());
            local speedFactor = math.min(self:getLastSpeed(), 20) / 20;
            maxTrackLength = maxTrackLength * (2 - speedFactor);
            --wheel.dirtAmount = math.max(wheel.dirtAmount - self.lastMovedDistance/maxTrackLength, 0);
            r, g, b = wheel.lastColor[1], wheel.lastColor[2], wheel.lastColor[3];
            a = 0; -- no depth to tyre tracks on road etc.
        end;
    end;
    return r, g, b, a, t;
end;

Washable.updateDirtAmount = Utils.overwrittenFunction(Washable.updateDirtAmount, RealDirtFix.updateDirtAmount);
Wheels.updateWheelDirtAmount = Utils.overwrittenFunction(Wheels.updateWheelDirtAmount, RealDirtFix.updateWheelDirtAmount);
Wheels.getTireTrackColor = Utils.overwrittenFunction(Wheels.getTireTrackColor, RealDirtFix.getTireTrackColor);